<?php
/**
    cf7cstmzr_form_text_color
    cf7cstmzr_form_bg_color
    cf7cstmzr_form_bg_img
    cf7cstmzr_form_text_size
    cf7cstmzr_form_padding
    cf7cstmzr_form_margin
    cf7cstmzr_form_border_width
    cf7cstmzr_form_border_radius
    cf7cstmzr_form_border_color

    cf7cstmzr_input_text_color
    cf7cstmzr_input_bg_color
    cf7cstmzr_input_padding
    cf7cstmzr_input_margin
    cf7cstmzr_input_text_size
    cf7cstmzr_input_border_width
    cf7cstmzr_input_border_radius
    cf7cstmzr_input_border_color

    cf7cstmzr_button_text_color
    cf7cstmzr_button_bg_color
    cf7cstmzr_button_text_color-hover
    cf7cstmzr_button_bg_color-hover
    cf7cstmzr_button_text_size
    cf7cstmzr_button_border_width
    cf7cstmzr_button_border_radius
    cf7cstmzr_button_border_color
    cf7cstmzr_button_border_color-hover

$input_text_color
$input_bg_color
$input_padding
$input_margin
$input_text_size
$input_border_width
$input_border_radius
$input_border_color

$button_text_color
$button_bg_color
$button_text_color_hover
$button_bg_color_hover
$button_text_size
$button_border_width
$button_border_radius
$button_border_color
$button_border_color_hover
 */

$plugin_version = Cf7_License::get_license_version();
$is_styled = get_option('cf7cstmzr-preview-styled', true);
$default_style_scheme_settings = Cf7_Style_Scheme::get_default_style_scheme();
$cache_form = get_option('cf7cstmzr_cache_form', '');
$is_fw = !empty($_GET['fw']) ? sanitize_text_field($_GET['fw']) : '';

$style_scheme_slug = 'default';

if ('free' !== $plugin_version) {
    $style_scheme_slug = !empty($_GET['style_scheme']) ? sanitize_text_field($_GET['style_scheme']) : 'default';
}

$style_schemes = get_option('cf7cstmzr_style_schemes', array());

if (empty($style_schemes)) {
    delete_option('cf7cstmzr_enabled_globally');
    $style_scheme_slug = 'default';
} else {
    if (empty($style_schemes[$style_scheme_slug])) {
        $style_scheme_slug = 'default';
    }
}


$enabled_globally = '';
$enabled_globally_title = '';
$enabled_globally_option = get_option('cf7cstmzr_enabled_globally', false);

if (!empty($enabled_globally_option)) {
    $enabled_globally = 'default';

    if ('free' !== $plugin_version) {
        $enabled_globally = $enabled_globally_option;
    }
}

if (!empty($enabled_globally)) {
    $enabled_globally_title = $style_schemes[$enabled_globally]['title'];
}

$style_scheme = Cf7_Style_Scheme::normalize_style_sheme($style_schemes, $style_scheme_slug);

$args = array (
    'numberposts' => -1,
    'orderby'     => 'title',
    'order'       => 'ASC',
    'post_type'   => 'wpcf7_contact_form',
    'post_status'   => 'publish',
    'suppress_filters' => false, // подавление работы фильтров изменения SQL запроса
);

$cf7_forms = get_posts($args);

$cf7_scheme_args = array (
    'numberposts' => -1,
    'orderby'     => 'title',
    'order'       => 'ASC',
    'post_type'   => 'wpcf7_contact_form',
    'post_status'   => 'publish',
    'suppress_filters' => false, // подавление работы фильтров изменения SQL запроса
    'meta_query' => array(
        'relation' => 'EXISTS',
        array(
            'key' => 'cf7cstmzr_style_scheme',
        )
    )
);

$forms_group_by_style_scheme = Cf7_Style_Scheme::get_forms_group_by_style_scheme();
$current_url_state = get_site_url() . '/wp-admin/admin.php?page=cf7cstmzr_page';

if (!empty($_GET['tab'])) {
    $current_url_state .= '&tab=' . sanitize_text_field($_GET['tab']);
}

if (!empty($_GET['style_scheme'])) {
    $current_url_state .= '&style_scheme=' . sanitize_text_field($_GET['style_scheme']);
}
?>
<div id="cf7cstmzr-main-container"<?php echo !empty($is_fw) ? ' class="fw"' : ''; ?>>
    <input type="hidden" id="cf7cstmzr-current-url" value="<?php echo $current_url_state; ?>">
    <div class="cf7cstmzr-row">
        <div class="cf7cstmzr-col">
            <div class="cf7cstmzr-col-inner">
                <!-- Style Scheme Settings - Start -->
                <div class="cf7cstmzr-settings-menu">
                    <form id="cf7cstmzr-settings-form">
                        <div id="cf7cstmzr-settings-container-header">
                            <div id="cf7cstmzr-settings-container-header-title" style="padding: 10px;margin:0 0 5px 0;background-color:#fff;border-top:5px solid #ccc; border-bottom: 1px solid #ccc;">
                                <h3 style="margin: 0;"><?php _e('Style schemes settings', 'cf7-styler'); ?></h3>

                                <span id="cf7cstmzr_to_fw" class="dashicons dashicons-editor-expand" title="<?php _e('Full Screen', 'cf7-styler') ?>"<?php echo !empty($is_fw) ? ' style="display:none;"' : ''; ?>></span>
                                <span id="cf7cstmzr_exit_fw" class="dashicons dashicons-editor-contract" title="<?php _e('Exit Full Screen', 'cf7-styler') ?>" <?php echo empty($is_fw) ? ' style="display:none;"' : ''; ?>></span>
                            </div>
                            <!-- Style Scheme Settings Control - Start -->
                            <div class="cf7cstmzr-settings-control">
                                <div class="cf7cstmzr-settings-control-inner">
                                    <?php
                                    if (!empty($style_schemes)) {
                                        ?>
                                        <div id="cf7cstmzr-settings-select" class="cf7cstmzr-settings-control-item">
                                            <?php
                                            ob_start();
                                            ?>
                                            <h4 class="cf7cstmzr-description-togler-holder" style="margin-top:0;">
                                                <?php echo $style_schemes[$style_scheme_slug]['title']; ?>
                                                <span class="dashicons dashicons-editor-help cf7cstmzr-description-togler" data-target="cf7cstmzr-select-scheme-description"></span>
                                            </h4>
                                            <?php
                                            $settings_select_content = ob_get_clean();

                                            if ( 'free' !== $plugin_version ) {
                                                ob_start();

                                                if (1 < count($style_schemes)) {
                                                    ?>
                                                    <h4 class="cf7cstmzr-description-togler-holder" style="margin-top:0;">
                                                        <?php _e('Style schemes list', 'cf7-styler'); ?>
                                                        <span class="dashicons dashicons-editor-help cf7cstmzr-description-togler" data-target="cf7cstmzr-select-scheme-description"></span>
                                                    </h4>

                                                    <select id="cf7cstmzr_select_style_scheme" class="cf7cstmzr-form-control" style="margin-bottom:10px;">
                                                        <?php
                                                        foreach ($style_schemes as $style_scheme_item_slug => $style_scheme_item) {
                                                            $style_forms_array = array();

                                                            if (!empty($forms_group_by_style_scheme[$style_scheme_item_slug])) {
                                                                $style_forms_array = $forms_group_by_style_scheme[$style_scheme_item_slug];
                                                            }

                                                            $style_forms_array_json = json_encode( $style_forms_array )
                                                            ?>
                                                            <option value="<?php echo $style_scheme_item_slug; ?>"<?php echo $style_scheme_item_slug === $style_scheme_slug ? ' selected' : ''; ?> data-forms='<?php echo $style_forms_array_json; ?>'>
                                                                <?php echo $style_scheme_item['title']; ?>
                                                            </option>
                                                            <?php
                                                        }
                                                        ?>
                                                    </select>
                                                    <?php
                                                    if ('default' !== $style_scheme_slug) {
                                                        ?>
                                                        <input id="cf7cstmzr-current-slug" type="hidden" value="<?php echo $style_scheme_slug ?>">
                                                        <input id="cf7cstmzr-current-title" type="hidden" value="<?php echo $style_schemes[$style_scheme_slug]['title']; ?>">
                                                        <?php
                                                    }

                                                    $settings_select_content = ob_get_clean();
                                                }
                                            }

                                            echo $settings_select_content;
                                            ?>
                                        </div>
                                        <?php

                                        if (!empty($cf7_forms)) {
                                            ?>
                                            <div>
                                                <?php
                                                if ($enabled_globally !== $style_scheme_slug) {
                                                    ?>
                                                    <div id="cf7cstmzr-select-scheme-description" style="display: none;">
                                                        <p style="margin-top:0;margin-bottom:10px;">
                                                            <small>
                                                                <?php
                                                                if (!empty($enabled_globally)) { // Check if any Scheme enabled
                                                                    echo sprintf( __( '<strong>%s</strong> used for all forms globally, click "Use for all forms" if you want to use current Scheme.', 'cf7-styler' ), $enabled_globally_title );
                                                                } else { // No scheme enabled
                                                                    _e('You do not use any of Style Schemes for Contact Form 7. Click "Use for all forms" to use current Scheme globally.', 'cf7-styler');
                                                                }
                                                                ?>
                                                            </small>
                                                        </p>
                                                    </div>

                                                    <div>
                                                        <button id="cf7cstmzr-enable-globally" class="button button-primary button-small" type="button" data-scheme="<?php echo $style_scheme_slug ?>">
                                                            <?php _e('Use for all forms', 'cf7-styler') ?>
                                                        </button>

                                                        <div style="padding-top: 3px;display: inline-block;margin-left: 10px;">
                                                            <input type="checkbox" value="1" id="cf7cstmzr-preview-unstyle"<?php echo empty($is_styled) ? ' checked' : '';?>> <?php _e('Preview Unstyled', 'cf7-styler') ?>
                                                        </div>
                                                    </div>
                                                    <?php
                                                } else {
                                                    ?>
                                                    <div id="cf7cstmzr-select-scheme-description" style="display: none;">
                                                        <p style="margin-top:0;margin-bottom:10px;">
                                                            <small>
                                                                <?php _e('This Style Scheme enabled globally for all forms. If you want to use your theme\'s style for Contact Form 7 click "Disable" button.', 'cf7-styler') ?>
                                                            </small>
                                                        </p>
                                                    </div>

                                                    <div>
                                                        <button id="cf7cstmzr-disable-globally" class="button button-primary button-small" type="button">
                                                            <?php _e('Disable', 'cf7-styler') ?>
                                                        </button>

                                                        <div style="padding-top: 3px;display: inline-block;margin-left: 10px;">
                                                            <input type="checkbox" value="1" id="cf7cstmzr-preview-unstyle"<?php echo empty($is_styled) ? ' checked' : '';?>> <?php _e('Preview Unstyled', 'cf7-styler') ?>
                                                        </div>
                                                    </div>
                                                    <?php
                                                }
                                                ?>
                                            </div>
                                            <?php

                                            if ('free' === $plugin_version) {
                                                ?>
                                                <div style="margin-top: 10px;">
                                                <span style="display: inline-block;margin-right: 10px;padding-top: 3px;">
                                                    <?php _e('Create multiple style schemes', 'cf7-styler') ?>
                                                </span>

                                                    <a class="button button-small button-success" href="admin.php?page=cf7cstmzr_page-pricing" target="_blank"><?php _e('Upgrade to Pro', 'cf7-styler') ?></a>
                                                </div>
                                                <?php
                                            }
                                        }
                                    } else {
                                        ?>
                                        <h4 style="margin-top: 0;margin-bottom: 10px;"><?php _e('Start with creating Default Style Scheme', 'cf7-styler') ?></h4>
                                        <?php
                                    }
                                    ?>
                                </div>
                            </div>
                            <!-- Style Scheme Settings Control - End -->

                            <!-- Style Scheme Settings Control - Start -->
                            <div class="cf7cstmzr-settings-control" style="margin-bottom:5px;">
                                <div class="cf7cstmzr-settings-control-inner">
                                    <div class="cf7cstmzr-settings-control-item">
                                        <button id="cf7cstmzr-settings-save" class="cf7cstmzr-settings-save button button-success button-icon" type="button" disabled="disabled" title="<?php _e("I'm happy with this! Save", 'cf7-styler') ?>">
                                            <span class="dashicons dashicons-yes" style="vertical-align: middle;"></span>
                                        </button>

                                        <?php
                                        if ('free' !== $plugin_version) {
                                            ?>
                                            <button id="cf7cstmzr-settings-save-as" class="cf7cstmzr-settings-save-as button button-success button-icon" type="button"<?php echo empty($style_schemes) ? ' style="display:none;"' : ''; ?> title="<?php _e("Create new style scheme!", 'cf7-styler') ?>">
                                                <span class="dashicons dashicons-plus" style="vertical-align: middle;"></span>
                                            </button>
                                            <?php
                                        }

                                        if (true) {
                                            ?>
                                            <button id="cf7cstmzr-settings-reset" class="cf7cstmzr-settings-reset button button-primary button-icon" type="button" title="<?php _e('Clean Styles', 'cf7-styler') ?>">
                                                <span class="dashicons dashicons-editor-removeformatting" style="vertical-align: middle;"></span>
                                            </button>

                                            <button id="cf7cstmzr-settings-default" class="cf7cstmzr-settings-default button button-primary" type="button" data-default-settings='<?php echo json_encode($default_style_scheme_settings['scheme']) ?>'>
                                                <?php _e('Reset to default', 'cf7-styler') ?>
                                            </button>
                                            <?php
                                        }

                                        if ('free' !== $plugin_version && !empty($style_schemes) && 'default' !== $style_scheme_slug) {
                                            ?>
                                            <button id="cf7cstmzr-settings-delete" class="cf7cstmzr-settings-delete button button-danger button-icon" type="button">
                                                <span class="dashicons dashicons-trash" style="vertical-align: middle;"></span>
                                            </button>
                                            <?php
                                        }
                                        ?>
                                    </div>

                                    <?php
                                    if ('free' !== $plugin_version) {
                                        ?>
                                        <div id="cf7cstmzr-settings-create-new" class="cf7cstmzr-settings-control-item" style="display: none">
                                            <input id="cf7cstmzr_settings_title_new" class="cf7cstmzr-form-control" type="text" value="" style="margin-bottom:10px" placeholder="<?php _e('Input style scheme title', 'cf7-styler') ?>">
                                            <p style="margin: 5px 0">
                                                <small>
                                                    <?php _e('You can create new style scheme with current scheme settings. If you want to create blank style schem unchek checkbox below.', 'cf7-styler') ?>
                                                </small>
                                            </p>

                                            <div style="margin-bottom: 10px;">
                                                <input id="cf7cstmzr_settings_copy_new" type="checkbox" value="1" checked><?php _e('Copy current style scheme settings', 'cf7-styler') ?>
                                            </div>

                                            <button id="cf7cstmzr-settings-create" class="cf7cstmzr-settings-create button button-primary" type="button"><?php _e('Create', 'cf7-styler') ?></button>
                                            <button id="cf7cstmzr-settings-save-as-cancel" class="cf7cstmzr-settings-save-as-cancel button" type="button"><?php _e('Cancel', 'cf7-styler') ?></button>
                                        </div>
                                        <?php
                                    }
                                    ?>

                                </div>

                                <input id="cf7cstmzr-url" type="hidden" value="<?php echo get_site_url() . '/cf7cstmzr-form-customizer/' ?>">
                                <input id="cf7cstmzr-admin-url" type="hidden" value="<?php echo get_site_url() . '/wp-admin/admin.php?page=cf7cstmzr_page&tab=form-customize' ?>">
                            </div>
                            <!-- Style Scheme Settings Control - End -->
                        </div>

                        <div id="cf7cstmzr-settings-container-body">

                            <?php
                            $web_safe_fonts = Cf7_Style_Scheme::get_web_safe_fonts();
                            ?>

                            <!-- Form Text - Start -->
                            <?php Cf7_Template::settings_item_start(__('Form Text', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_form_text_color"><?php _e('Text Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_form_text_color" name="cf7cstmzr_form_text_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['form_text_color']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_form_text_size"><?php _e('Font Size', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_form_text_size" name="cf7cstmzr_form_text_size" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" min="1" type="number" value="<?php echo $style_scheme['form_text_size']; ?>">
                                        </div>
                                    </div>


                                    <label for="cf7cstmzr_form_text_font-family"><?php _e('Font Family', 'cf7-styler') ?></label>
                                    <select name="cf7cstmzr_form_text_font-family" id="cf7cstmzr_form_text_font-family" class="cf7cstmzr-form-control cf7cstmzr-dropdown-field" style="max-width:200px;">
                                        <option value=""><?php _e('- select -', 'cf7-styler') ?></option>
                                        <?php
                                        foreach ($web_safe_fonts as $font_slug => $font_family) {
                                            ?>
                                            <option value="<?php echo $font_slug; ?>"<?php echo $style_scheme['form_text_font_family'] === $font_slug ? ' selected' : ''; ?>><?php echo $font_family[0]; ?></option>
                                            <?php
                                        }
                                        ?>
                                    </select>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label>
                                        <?php _e('Links Settings', 'cf7-styler') ?>
                                    </label>

                                    <div style="display: inline-block">
                                        <label for="cf7cstmzr_form_text_link-color"><?php _e('Links Color', 'cf7-styler') ?></label>
                                        <input id="cf7cstmzr_form_text_link-color" name="cf7cstmzr_form_text_link-color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['form_text_link_color']; ?>">
                                    </div>

                                    <div style="display: inline-block">
                                        <label for="cf7cstmzr_form_text_link-hover-color"><?php _e('Links Hover Color', 'cf7-styler') ?></label>
                                        <input id="cf7cstmzr_form_text_link-hover-color" name="cf7cstmzr_form_text_link-hover-color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['form_text_link_hover_color']; ?>">
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label>
                                        <?php _e('Labels Settings', 'cf7-styler') ?>
                                    </label>

                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_form_text_label-color"><?php _e('Labels Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_form_text_label-color" name="cf7cstmzr_form_text_label-color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['form_text_label_color']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_form_text_label-size"><?php _e('Labels Font Size', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_form_text_label-size" name="cf7cstmzr_form_text_label-size" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" min="1" type="number" value="<?php echo $style_scheme['form_text_label_size']; ?>">
                                        </div>
                                    </div>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Form Text - End -->

                            <!-- Form BG Image & Colors - Start -->
                            <?php Cf7_Template::settings_item_start(__('Form BG Image & Colors', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label for="cf7cstmzr_form_bg_color"><?php _e('Background Color', 'cf7-styler') ?></label>
                                    <input id="cf7cstmzr_form_bg_color" name="cf7cstmzr_form_bg_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['form_bg_color']; ?>">
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label for="cf7cstmzr_form_bg_img"><?php _e('Background Image', 'cf7-styler') ?></label>

                                    <div id="cf7cstmzr_uploaded_image_holder">
                                        <?php
                                        if (!empty($style_scheme['form_bg_img'])) {
                                            $image_attributes = wp_get_attachment_image_src( $style_scheme['form_bg_img'], 'full' );
                                            ?>
                                            <img src="<?php echo $image_attributes[0] ?>" alt="">
                                            <?php
                                        }
                                        ?>
                                    </div>

                                    <input id="cf7cstmzr_form_bg_img" name="cf7cstmzr_form_bg_img" type="hidden" value="<?php echo $style_scheme['form_bg_img'] ?>"><br>

                                    <button id="cf7cstmzr_upload_image_btn" class="button button-primary button-small" type="button"<?php echo !empty($style_scheme['form_bg_img']) ? ' style="display:none;"' : '' ?>>
                                        <?php _e('Upload Image', 'cf7-styler'); ?>
                                    </button>

                                    <button id="cf7cstmzr_delete_image_btn" class="button button-primary button-small" type="button"<?php echo empty($style_scheme['form_bg_img']) ? ' style="display:none;"' : '' ?>>
                                        <?php _e('Delete Image', 'cf7-styler'); ?>
                                    </button>

                                    <div id="cf7cstmzr_form_bg_img-opacity-holder" style="margin-top: 10px;<?php echo empty($style_scheme['form_bg_img']) ? ' display: none;' : ''; ?>">
                                        <label for="cf7cstmzr_form_bg_img-opacity"><?php _e('Image Opacity', 'cf7-styler') ?></label>
                                        <input id="cf7cstmzr_form_bg_img-opacity" name="cf7cstmzr_form_bg_img-opacity" class="cf7cstmzr-number cf7cstmzr-form-control" min="0" max="1" step="0.1" type="number" value="<?php echo $style_scheme['form_bg_img_opacity']; ?>">
                                    </div>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Form BG Image & Colors - End -->

                            <!-- Form Padding, Margin & Border - Start -->
                            <?php Cf7_Template::settings_item_start(__('Form Padding, Margin & Border', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php
                                    $form_padding = false;

                                    if (
                                        ($style_scheme['form_padding_top'] === $style_scheme['form_padding_right']) &&
                                        ($style_scheme['form_padding_right'] === $style_scheme['form_padding_bottom']) &&
                                        ($style_scheme['form_padding_bottom'] === $style_scheme['form_padding_left'])
                                    ) {
                                        $form_padding = $style_scheme['form_padding_top'];
                                    }
                                    ?>
                                    <label for="cf7cstmzr_form_padding"><?php _e('Padding', 'cf7-styler') ?></label>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations-main"<?php echo false !== $form_padding ? '' : ' style="display:none;"' ?>>
                                        <input id="cf7cstmzr_form_padding" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-parent-input cf7cstmzr-parent-text-field" type="number" min="0" value="<?php echo $form_padding; ?>">
                                        <span class="dashicons dashicons-arrow-down-alt2"></span>
                                    </div>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations"<?php echo false === $form_padding ? '' : ' style="display:none;"' ?>>
                                        <label for="cf7cstmzr_form_padding-top" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-up-alt"></span></label>
                                        <input id="cf7cstmzr_form_padding-top" name="cf7cstmzr_form_padding_top" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_padding_top']; ?>">
                                        <label for="cf7cstmzr_form_padding-right" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-right-alt"></span></label>
                                        <input id="cf7cstmzr_form_padding-right" name="cf7cstmzr_form_padding_right" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_padding_right']; ?>"><br>
                                        <label for="cf7cstmzr_form_padding-bottom" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-down-alt"></span></label>
                                        <input id="cf7cstmzr_form_padding-bottom" name="cf7cstmzr_form_padding_bottom" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_padding_bottom']; ?>">
                                        <label for="cf7cstmzr_form_padding-left" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-left-alt"></span></label>
                                        <input id="cf7cstmzr_form_padding-left" name="cf7cstmzr_form_padding_left" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_padding_left']; ?>">
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php
                                    $form_margin = false;

                                    if (
                                        ($style_scheme['form_margin_top'] === $style_scheme['form_margin_right']) &&
                                        ($style_scheme['form_margin_right'] === $style_scheme['form_margin_bottom']) &&
                                        ($style_scheme['form_margin_bottom'] === $style_scheme['form_margin_left'])
                                    ) {
                                        $form_margin = $style_scheme['form_margin_top'];
                                    }
                                    ?>
                                    <label for="cf7cstmzr_form_margin"><?php _e('Margin', 'cf7-styler') ?></label>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations-main"<?php echo false !== $form_margin ? '' : ' style="display:none;"' ?>>
                                        <input id="cf7cstmzr_form_margin" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-parent-input cf7cstmzr-parent-text-field" type="number" min="0" value="<?php echo $form_margin; ?>">
                                        <span class="dashicons dashicons-arrow-down-alt2"></span>
                                    </div>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations"<?php echo false === $form_margin ? '' : ' style="display:none;"' ?>>
                                        <label for="cf7cstmzr_form_margin-top" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-up-alt"></span></label>
                                        <input id="cf7cstmzr_form_margin-top" name="cf7cstmzr_form_margin_top" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_margin_top']; ?>">
                                        <label for="cf7cstmzr_form_margin-right" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-right-alt"></span></label>
                                        <input id="cf7cstmzr_form_margin-right" name="cf7cstmzr_form_margin_right" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_margin_right']; ?>"><br>
                                        <label for="cf7cstmzr_form_margin-bottom" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-down-alt"></span></label>
                                        <input id="cf7cstmzr_form_margin-bottom" name="cf7cstmzr_form_margin_bottom" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_margin_bottom']; ?>">
                                        <label for="cf7cstmzr_form_margin-left" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-left-alt"></span></label>
                                        <input id="cf7cstmzr_form_margin-left" name="cf7cstmzr_form_margin_left" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_margin_left']; ?>">
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php
                                    $form_border_width = false;

                                    if (
                                        ($style_scheme['form_border_width_top'] === $style_scheme['form_border_width_right']) &&
                                        ($style_scheme['form_border_width_right'] === $style_scheme['form_border_width_bottom']) &&
                                        ($style_scheme['form_border_width_bottom'] === $style_scheme['form_border_width_left'])
                                    ) {
                                        $form_border_width = $style_scheme['form_border_width_top'];
                                    }
                                    ?>
                                    <label for="cf7cstmzr_form_border_width"><?php _e('Border Width', 'cf7-styler') ?></label>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations-main"<?php echo false !== $form_border_width ? '' : ' style="display:none;"' ?>>
                                        <input id="cf7cstmzr_form_border_width" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-parent-input cf7cstmzr-parent-text-field" type="number" min="0" value="<?php echo $form_border_width; ?>">
                                        <span class="dashicons dashicons-arrow-down-alt2"></span>
                                    </div>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations"<?php echo false === $form_border_width ? ' style="margin-bottom:10px;"' : ' style="display:none;"' ?>>
                                        <label for="cf7cstmzr_form_border_width-top" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-up-alt"></span></label>
                                        <input id="cf7cstmzr_form_border_width-top" name="cf7cstmzr_form_border_width_top" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_border_width_top']; ?>">

                                        <label for="cf7cstmzr_form_border_width-right" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-right-alt"></span></label>
                                        <input id="cf7cstmzr_form_border_width-right" name="cf7cstmzr_form_border_width_right" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_border_width_right']; ?>"><br>

                                        <label for="cf7cstmzr_form_border_width-bottom" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-down-alt"></span></label>
                                        <input id="cf7cstmzr_form_border_width-bottom" name="cf7cstmzr_form_border_width_bottom" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_border_width_bottom']; ?>">

                                        <label for="cf7cstmzr_form_border_width-left" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-left-alt"></span></label>
                                        <input id="cf7cstmzr_form_border_width-left" name="cf7cstmzr_form_border_width_left" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['form_border_width_left']; ?>">
                                    </div>

                                    <div>
                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_form_border_radius"><?php _e('Border Radius', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_form_border_radius" name="cf7cstmzr_form_border_radius" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" type="number" value="<?php echo $style_scheme['form_border_radius']; ?>">
                                        </div>

                                        <div style="display: inline-block;vertical-align: top;">
                                            <label for="cf7cstmzr_form_border_color"><?php _e('Border Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_form_border_color" name="cf7cstmzr_form_border_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['form_border_color']; ?>">
                                        </div>
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php Cf7_Template::setting_shadow($style_scheme, 'form'); ?>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Form Padding, Margin & Border - End -->

                            <!-- Input Fields Text and Colors - Start -->
                            <?php Cf7_Template::settings_item_start(__('Input Fields Text and Colors', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label for="cf7cstmzr_input_width"><?php _e('Make input fields full width?', 'cf7-styler') ?></label>

                                    <input id="cf7cstmzr_input_width_yes" name="cf7cstmzr_input_full-width" class="cf7cstmzr-radio-field" type="radio" value="yes"<?php echo 'yes' === $style_scheme['input_full_width'] ? ' checked' : ''; ?>>
                                    <label for="cf7cstmzr_input_width_yes" class="cf7cstmzr_inline_label"><?php _e('YES', 'cf7-styler') ?></label>
                                    <br>
                                    <input id="cf7cstmzr_input_width_no" name="cf7cstmzr_input_full-width" class="cf7cstmzr-radio-field" type="radio" value="no"<?php echo 'no' === $style_scheme['input_full_width'] ? ' checked' : ''; ?>>
                                    <label for="cf7cstmzr_input_width_no" class="cf7cstmzr_inline_label"><?php _e('NO', 'cf7-styler') ?></label>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_input_text_size"><?php _e('Font Size', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_input_text_size" name="cf7cstmzr_input_text_size" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" type="number" value="<?php echo $style_scheme['input_text_size']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_input_text_line-height"><?php _e('Line Height', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_input_text_line-height" name="cf7cstmzr_input_text_line-height" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" min="0" step="0.1" type="number" value="<?php echo $style_scheme['input_text_line_height']; ?>">
                                        </div>
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_input_text_color"><?php _e('Text Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_input_text_color" name="cf7cstmzr_input_text_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['input_text_color']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_input_bg_color"><?php _e('BG Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_input_bg_color" name="cf7cstmzr_input_bg_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['input_bg_color']; ?>">

                                        </div>
                                    </div>
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top"><label for="cf7cstmzr_input_bg_color-opacity"><?php _e('BG Opacity', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_input_bg_color-opacity" name="cf7cstmzr_input_bg_color-opacity" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" min="0" max="1" step="0.1" type="number" value="<?php echo $style_scheme['input_bg_color_opacity']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                        </div>
                                    </div>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Input Fields Text and Colors - End -->

                            <!-- Input Fields Padding, Margin - Start -->
                            <?php Cf7_Template::settings_item_start(__('Input Fields Padding & Margin', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php
                                    $input_padding = false;

                                    if (
                                        ($style_scheme['input_padding_top'] === $style_scheme['input_padding_right']) &&
                                        ($style_scheme['input_padding_right'] === $style_scheme['input_padding_bottom']) &&
                                        ($style_scheme['input_padding_bottom'] === $style_scheme['input_padding_left'])
                                    ) {
                                        $input_padding = $style_scheme['input_padding_top'];
                                    }
                                    ?>

                                    <label for="cf7cstmzr_input_padding"><?php _e('Padding', 'cf7-styler') ?></label>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations-main"<?php echo false !== $input_padding ? '' : ' style="display:none;"' ?>>
                                        <input id="cf7cstmzr_input_padding" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-parent-input cf7cstmzr-parent-text-field" type="number" min="0" value="<?php echo $input_padding; ?>">
                                        <span class="dashicons dashicons-arrow-down-alt2"></span>
                                    </div>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations"<?php echo false === $input_padding ? '' : ' style="display:none;"' ?>>
                                        <label for="cf7cstmzr_input_padding-top" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-up-alt"></span></label>
                                        <input id="cf7cstmzr_input_padding-top" name="cf7cstmzr_input_padding_top" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_padding_top']; ?>">
                                        <label for="cf7cstmzr_input_padding-right" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-right-alt"></span></label>
                                        <input id="cf7cstmzr_input_padding-right" name="cf7cstmzr_input_padding_right" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_padding_right']; ?>"><br>
                                        <label for="cf7cstmzr_input_padding-bottom" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-down-alt"></span></label>
                                        <input id="cf7cstmzr_input_padding-bottom" name="cf7cstmzr_input_padding_bottom" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_padding_bottom']; ?>">
                                        <label for="cf7cstmzr_input_padding-left" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-left-alt"></span></label>
                                        <input id="cf7cstmzr_input_padding-left" name="cf7cstmzr_input_padding_left" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_padding_left']; ?>">
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php
                                    $input_margin = false;

                                    if (
                                        ($style_scheme['input_margin_top'] === $style_scheme['input_margin_right']) &&
                                        ($style_scheme['input_margin_right'] === $style_scheme['input_margin_bottom']) &&
                                        ($style_scheme['input_margin_bottom'] === $style_scheme['input_margin_left'])
                                    ) {
                                        $input_margin = $style_scheme['input_margin_top'];
                                    }
                                    ?>
                                    <label for="cf7cstmzr_input_margin"><?php _e('Margin', 'cf7-styler') ?></label>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations-main"<?php echo false !== $input_margin ? '' : ' style="display:none;"' ?>>
                                        <input id="cf7cstmzr_input_margin" name="cf7cstmzr_input_margin" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-parent-input cf7cstmzr-parent-text-field" type="number" min="0" value="<?php echo $input_margin; ?>">
                                        <span class="dashicons dashicons-arrow-down-alt2"></span>
                                    </div>

                                    <div class="cf7cstmzr-settings-item-body-setting-variations"<?php echo false === $input_margin ? '' : ' style="display:none;"' ?>>
                                        <label for="cf7cstmzr_input_margin-top" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-up-alt"></span></label>
                                        <input id="cf7cstmzr_input_margin-top" name="cf7cstmzr_input_margin_top" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_margin_top']; ?>">
                                        <label for="cf7cstmzr_input_margin-right" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-right-alt"></span></label>
                                        <input id="cf7cstmzr_input_margin-right" name="cf7cstmzr_input_margin_right" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_margin_right']; ?>"><br>
                                        <label for="cf7cstmzr_input_margin-bottom" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-down-alt"></span></label>
                                        <input id="cf7cstmzr_input_margin-bottom" name="cf7cstmzr_input_margin_bottom" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_margin_bottom']; ?>">
                                        <label for="cf7cstmzr_input_margin-left" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-left-alt"></span></label>
                                        <input id="cf7cstmzr_input_margin-left" name="cf7cstmzr_input_margin_left" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_margin_left']; ?>">
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php
                                    $input_border_width = false;

                                    if (
                                        ($style_scheme['input_border_width_top'] === $style_scheme['input_border_width_right']) &&
                                        ($style_scheme['input_border_width_right'] === $style_scheme['input_border_width_bottom']) &&
                                        ($style_scheme['input_border_width_bottom'] === $style_scheme['input_border_width_left'])
                                    ) {
                                        $input_border_width = $style_scheme['input_border_width_top'];
                                    }
                                    ?>
                                    <label for="cf7cstmzr_input_border_width"><?php _e('Border', 'cf7-styler') ?></label>

                                    <div style="margin-bottom: 10px;">
                                        <div class="cf7cstmzr-settings-item-body-setting-variations-main"<?php echo false !== $input_border_width ? '' : ' style="display:none;"' ?>>
                                            <input id="cf7cstmzr_input_border_width" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-parent-input cf7cstmzr-parent-text-field" type="number" min="0" value="<?php echo $input_border_width; ?>">
                                            <span class="dashicons dashicons-arrow-down-alt2"></span>
                                        </div>

                                        <div class="cf7cstmzr-settings-item-body-setting-variations"<?php echo false === $input_border_width ? '' : ' style="display:none;"' ?>>
                                            <label for="cf7cstmzr_input_border_width-top" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-up-alt"></span></label>
                                            <input id="cf7cstmzr_input_border_width-top" name="cf7cstmzr_input_border_width_top" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_border_width_top']; ?>">

                                            <label for="cf7cstmzr_input_border_width-right" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-right-alt"></span></label>
                                            <input id="cf7cstmzr_input_border_width-right" name="cf7cstmzr_input_border_width_right" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_border_width_right']; ?>"><br>

                                            <label for="cf7cstmzr_input_border_width-bottom" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-down-alt"></span></label>
                                            <input id="cf7cstmzr_input_border_width-bottom" name="cf7cstmzr_input_border_width_bottom" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_border_width_bottom']; ?>">

                                            <label for="cf7cstmzr_input_border_width-left" class="cf7cstmzr_inline_label"><span class="dashicons dashicons-arrow-left-alt"></span></label>
                                            <input id="cf7cstmzr_input_border_width-left" name="cf7cstmzr_input_border_width_left" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-inline-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['input_border_width_left']; ?>">
                                        </div>
                                    </div>

                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_input_border_radius"><?php _e('Radius', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_input_border_radius" name="cf7cstmzr_input_border_radius" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" type="number" value="<?php echo $style_scheme['input_border_radius']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_input_border_color"><?php _e('Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_input_border_color" name="cf7cstmzr_input_border_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['input_border_color']; ?>">
                                        </div>
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php Cf7_Template::setting_shadow($style_scheme, 'input'); ?>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Input Fields Padding, Margin & Borders - End -->

                            <!-- Checkboxes & Radiobuttons - Start -->
                            <?php Cf7_Template::settings_item_start(__('Checkboxes & Radiobuttons', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label for="cf7cstmzr_input_width"><?php _e('Make checkbox item one per line', 'cf7-styler') ?></label>

                                    <input id="cf7cstmzr_checkbox_width_yes" name="cf7cstmzr_checkbox_full-width" class="cf7cstmzr-radio-field" type="radio" value="yes"<?php echo 'yes' === $style_scheme['checkbox_full_width'] ? ' checked' : ''; ?>>
                                    <label for="cf7cstmzr_checkbox_width_yes" class="cf7cstmzr_inline_label"><?php _e('YES', 'cf7-styler') ?></label>
                                    <br>
                                    <input id="cf7cstmzr_checkbox_width_no" name="cf7cstmzr_checkbox_full-width" class="cf7cstmzr-radio-field" type="radio" value="no"<?php echo 'no' === $style_scheme['checkbox_full_width'] ? ' checked' : ''; ?>>
                                    <label for="cf7cstmzr_checkbox_width_no" class="cf7cstmzr_inline_label"><?php _e('NO', 'cf7-styler') ?></label>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label for="cf7cstmzr_radiobutton_width"><?php _e('Make radiobutton item one per line', 'cf7-styler') ?></label>

                                    <input id="cf7cstmzr_radiobutton_width_yes" name="cf7cstmzr_radiobutton_full-width" class="cf7cstmzr-radio-field" type="radio" value="yes"<?php echo 'yes' === $style_scheme['radiobutton_full_width'] ? ' checked' : ''; ?>>
                                    <label for="cf7cstmzr_radiobutton_width_yes" class="cf7cstmzr_inline_label"><?php _e('YES', 'cf7-styler') ?></label>
                                    <br>
                                    <input id="cf7cstmzr_radiobutton_width_no" name="cf7cstmzr_radiobutton_full-width" class="cf7cstmzr-radio-field" type="radio" value="no"<?php echo 'no' === $style_scheme['radiobutton_full_width'] ? ' checked' : ''; ?>>
                                    <label for="cf7cstmzr_radiobutton_width_no" class="cf7cstmzr_inline_label"><?php _e('NO', 'cf7-styler') ?></label>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <div style="display: inline-block; vertical-align: top">
                                        <label for="cf7cstmzr_checkbox_text_label-size"><?php _e('Labels Font Size', 'cf7-styler') ?></label>
                                        <input id="cf7cstmzr_checkbox_text_label-size" name="cf7cstmzr_checkbox_text_label-size" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" min="1" type="number" value="<?php echo $style_scheme['checkbox_text_label_size']; ?>">
                                    </div>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Checkboxes & Radiobuttons - End -->

                            <!-- Button Text & Colors - Start -->
                            <?php Cf7_Template::settings_item_start(__('Button Size, Text & Colors', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_input_width"><?php _e('Make full width?', 'cf7-styler') ?></label>

                                            <input id="cf7cstmzr_button_width_yes" name="cf7cstmzr_button_full-width" class="cf7cstmzr-radio-field" type="radio" value="yes"<?php echo 'yes' === $style_scheme['button_full_width'] ? ' checked' : ''; ?>>
                                            <label for="cf7cstmzr_button_width_yes" class="cf7cstmzr_inline_label"><?php _e('YES', 'cf7-styler') ?></label>
                                            <br>
                                            <input id="cf7cstmzr_button_width_no" name="cf7cstmzr_button_full-width" class="cf7cstmzr-radio-field" type="radio" value="no"<?php echo 'no' === $style_scheme['button_full_width'] ? ' checked' : ''; ?>>
                                            <label for="cf7cstmzr_button_width_no" class="cf7cstmzr_inline_label"><?php _e('NO', 'cf7-styler') ?></label>
                                        </div>

                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_button_padding"><?php _e('Padding', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_padding" name="cf7cstmzr_button_padding" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" min="0" type="number" value="<?php echo $style_scheme['button_padding']; ?>">
                                        </div>
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_button_text_color"><?php _e('Text Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_text_color" name="cf7cstmzr_button_text_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['button_text_color']; ?>">
                                        </div>

                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_button_text_color-hover"><?php _e('Hover Text Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_text_color-hover" name="cf7cstmzr_button_text_color-hover" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['button_text_color_hover']; ?>">
                                        </div>
                                    </div>

                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_button_bg_color"><?php _e('BG Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_bg_color" name="cf7cstmzr_button_bg_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['button_bg_color']; ?>">
                                        </div>

                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_button_bg_color-hover"><?php _e('Hover BG Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_bg_color-hover" name="cf7cstmzr_button_bg_color-hover" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['button_bg_color_hover']; ?>">
                                        </div>
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_button_text_size"><?php _e('Font Size', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_text_size" name="cf7cstmzr_button_text_size" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" type="number" value="<?php echo $style_scheme['button_text_size']; ?>">
                                        </div>

                                        <div style="display: inline-block;vertical-align: top;margin-right: 10px;">
                                            <label for="cf7cstmzr_button_text_line-height"><?php _e('Line Height', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_text_line-height" name="cf7cstmzr_button_text_line-height" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" min="0" step="0.1" type="number" value="<?php echo $style_scheme['button_text_line_height']; ?>">
                                        </div>
                                    </div>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Button Text & Colors - End -->

                            <!-- Button Borders - Start -->
                            <?php Cf7_Template::settings_item_start(__('Button Border & Shadow', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label><?php _e('Button Border', 'cf7-styler') ?></label>
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_button_border_width"><?php _e('Width', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_border_width" name="cf7cstmzr_button_border_width" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" type="number" value="<?php echo $style_scheme['button_border_width']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_button_border_radius"><?php _e('Radius', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_border_radius" name="cf7cstmzr_button_border_radius" class="cf7cstmzr-number cf7cstmzr-form-control cf7cstmzr-text-field" type="number" value="<?php echo $style_scheme['button_border_radius']; ?>">
                                        </div>
                                    </div>
                                    <div style="margin-bottom: 10px;">
                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_button_border_color"><?php _e('Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_border_color" name="cf7cstmzr_button_border_color" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['button_border_color']; ?>">
                                        </div>

                                        <div style="display: inline-block; vertical-align: top">
                                            <label for="cf7cstmzr_button_border_color-hover"><?php _e('Hover Color', 'cf7-styler') ?></label>
                                            <input id="cf7cstmzr_button_border_color-hover" name="cf7cstmzr_button_border_color-hover" class="cf7cstmzr-color-picker" type="text" value="<?php echo $style_scheme['button_border_color_hover']; ?>">
                                        </div>
                                    </div>
                                </div>

                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <?php Cf7_Template::setting_shadow($style_scheme, 'button'); ?>
                                </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Button Borders - End -->

                            <!-- Custom Styles - Start -->
                            <?php Cf7_Template::settings_item_start(__('Custom CSS', 'cf7-styler')); ?>
                                <div class="cf7cstmzr-settings-item-body-setting">
                                    <label for="cf7cstmzr_custom_css"><?php _e('Custom CSS Code', 'cf7-styler') ?></label>

                                    <textarea name="cf7cstmzr_custom_css" id="cf7cstmzr_custom-css" class="widefat textarea" cols="30" rows="10"><?php echo $style_scheme['custom_css']; ?></textarea>
                            </div>
                            <?php Cf7_Template::settings_item_end(); ?>
                            <!-- Custom Styles - End -->
                        </div>
                    </form>
                </div>
                <!-- Style Scheme Settings - End -->
            </div>
        </div>

        <div class="cf7cstmzr-col-wide">
            <!-- Select Form - Start -->
            <div id="cf7cstmzr-preview-container-header">
                <div id="cf7cstmzr-preview-container-header-title" style="padding: 10px;margin:0 0 5px 0;background-color:#fff;border-top:5px solid #ccc; border-bottom: 1px solid #ccc;">
                    <h3 style="margin:0;"><?php _e('Style schemes preview', 'cf7-styler'); ?></h3>

                    <div class="cf7cstmzr-preview-control-icons only-desktop" style="display: inline-block;">
                        <span class="dashicons dashicons-desktop" title="<?php _e('Desktop View', 'cf7-styler') ?>"></span>
                        <span class="dashicons dashicons-tablet" title="<?php _e('Tablet View', 'cf7-styler') ?>"></span>
                        <span class="dashicons dashicons-smartphone" title="<?php _e('Mobile View', 'cf7-styler') ?>"></span>
                    </div>
                </div>

                <div id="select-form-container" class="cf7cstmzr-settings-control">
                    <div class="cf7cstmzr-settings-control-inner">
                        <?php
                        if (!empty($cf7_forms)) {
                            $show_description = 'free' !== $plugin_version && !empty($style_schemes);
                            ?>
                            <div class="cf7cstmzr-container-with-description">
                                <h4<?php echo $show_description ? ' class="cf7cstmzr-description-togler-holder"' : ''; ?>>
                                    <?php
                                    if (1 === count($cf7_forms)) {
                                        echo get_the_title($cf7_forms[0]->ID);
                                    } else {
                                        echo __('Contact form 7 list', 'cf7-styler');
                                    }

                                    if ($show_description) {
                                        ?><span class="dashicons dashicons-editor-help cf7cstmzr-description-togler" data-target="cf7cstmzr-select-form-description"></span><?php
                                    }
                                    ?>

                                </h4>

                                <select id="cf7cstmzr_select_form" class="cf7cstmzr-form-control"<?php echo 1 === count($cf7_forms) ? ' style="display:none;"' : ' style="margin-bottom:10px;"'; ?>>
                                    <?php
                                    $i = 1;
                                    $first_form_scheme = '';
                                    $first_form_scheme_title = '';
                                    foreach ($cf7_forms as $cf7_form) {
                                        $form_style_scheme_data = '';
                                        $form_style_scheme_data_title = '';

                                        $cf7cstmzr_style_scheme = get_post_meta( $cf7_form->ID, 'cf7cstmzr_style_scheme', true );

                                        if (!empty($cf7cstmzr_style_scheme)) {
                                            if (!empty($style_schemes[$cf7cstmzr_style_scheme])) {
                                                $form_style_scheme_data = $cf7cstmzr_style_scheme;
                                                $form_style_scheme_data_title = $style_schemes[$cf7cstmzr_style_scheme]['title'];

                                                if (1 === $i) {
                                                    $first_form_scheme = $cf7cstmzr_style_scheme;
                                                    $first_form_scheme_title = $style_schemes[$cf7cstmzr_style_scheme]['title'];
                                                }
                                            } else {

                                            }
                                        }
                                        ?>
                                        <option
                                                value="<?php echo $cf7_form->ID ?>"
                                                data-scheme="<?php echo $form_style_scheme_data; ?>"
                                                data-scheme-title="<?php echo $form_style_scheme_data_title; ?>"
                                                data-scheme-global="<?php echo $enabled_globally; ?>"
                                                data-scheme-global-title="<?php echo $enabled_globally_title; ?>"
                                                <?php echo (int)$cache_form === (int)$cf7_form->ID ? ' selected' : ''; ?>
                                        >
                                            <?php echo get_the_title($cf7_form->ID); ?>
                                        </option>
                                        <?php
                                        $i++;
                                    }
                                    ?>
                                </select>

                                <?php
                                if ($show_description) {
                                    ?>
                                    <div id="cf7cstmzr-select-form-description" class="cf7cstmzr-description" style="display:none;">
                                        <?php
                                        if ( $style_scheme_slug === $first_form_scheme ) { // This form styled with current style scheme
                                            $display_enabled_message = ' style="display:block;"';
                                            $display_enabled_another_message = ' style="display:none;"';
                                            $display_disabled_message = ' style="display:none;"';
                                            $display_disabled_globally_message = ' style="display:none;"';
                                            $display_enabled_button = ' style="display:none;"';
                                            $display_disabled_button = ' style="display:inline-block;"';
                                        } elseif( !empty( $first_form_scheme ) ) {
                                            $display_enabled_message = ' style="display:none;"';
                                            $display_enabled_another_message = ' style="display:block;"';
                                            $display_disabled_message = ' style="display:none;"';
                                            $display_disabled_globally_message = ' style="display:none;"';
                                            $display_enabled_button = ' style="display:inline-block;"';
                                            $display_disabled_button = ' style="display:none;"';
                                        } elseif( !empty( $enabled_globally ) ) {
                                            $display_enabled_message = ' style="display:none;"';
                                            $display_enabled_another_message = ' style="display:none;"';
                                            $display_disabled_message = ' style="display:block;"';
                                            $display_disabled_globally_message = ' style="display:none;"';
                                            $display_enabled_button = ' style="display:inline-block;"';
                                            $display_disabled_button = ' style="display:none;"';
                                        } else {
                                            $display_enabled_message = ' style="display:none;"';
                                            $display_enabled_another_message = ' style="display:none;"';
                                            $display_disabled_message = ' style="display:none;"';
                                            $display_disabled_globally_message = ' style="display:block;"';
                                            $display_enabled_button = ' style="display:inline-block;"';
                                            $display_disabled_button = ' style="display:none;"';
                                        }
                                        ?>
                                        <p style="margin-top:0;margin-bottom:5px;">
                                            <small id="cf7cstmzr-enabled-message"<?php echo $display_enabled_message; ?>>
                                                <?php _e('This form is styled with current Style Scheme, you can disable it and use global settings.', 'cf7-styler') ?>
                                            </small>

                                            <small id="cf7cstmzr-enabled-another-message"<?php echo $display_enabled_another_message; ?>>
                                                <?php echo sprintf( __( 'This form is styled with <strong>%s</strong>, you can style it with current Style scheme.', 'cf7-styler' ), $first_form_scheme_title ); ?>
                                            </small>

                                            <small id="cf7cstmzr-disabled-message"<?php echo $display_disabled_message; ?>>
                                                <?php _e('This form is styled with <strong>Global - Style Sheme</strong>, you can enable current Scheme for this form.', 'cf7-styler') ?>
                                            </small>

                                            <small id="cf7cstmzr-disabled-globally-message"<?php echo $display_disabled_globally_message; ?>>
                                                <?php _e('This form not styled with any Style scheme, you can enable current Scheme for this form or set up global Style Scheme by clicking "Use for all forms" below scheme title.', 'cf7-styler') ?>
                                            </small>
                                        </p>
                                    </div>

                                    <div>
                                        <button id="cf7cstmzr-enable-for-form" class="button button-primary button-small" type="button" data-scheme="<?php echo $style_scheme_slug ?>"<?php echo $display_enabled_button; ?>>
                                            <?php _e('Style with current scheme', 'cf7-styler') ?>
                                        </button>

                                        <button id="cf7cstmzr-disable-for-form" class="button button-primary button-small" type="button" data-scheme="<?php echo $first_form_scheme ?>"<?php echo $display_disabled_button; ?>>
                                            <?php _e('Disable current scheme', 'cf7-styler') ?>
                                        </button>
                                    </div>
                                    <?php
                                } else {
                                    ?>
                                    <div>
                                        <span style="display: inline-block;margin-right: 10px;padding-top: 3px;">
                                            <?php _e('Style each form separately', 'cf7-styler') ?>
                                        </span>

                                        <a class="button button-small button-success" href="admin.php?page=cf7cstmzr_page-pricing" target="_blank"><?php _e('Upgrade to Pro', 'cf7-styler') ?></a>
                                    </div>
                                    <?php
                                }
                                ?>
                            </div>
                            <?php
                        } else {
                            ?>
                            <h4 style="margin-top:0;margin-bottom:10px;font-size:16px;"><?php _e('You do not have any Contact Form 7 items', 'cf7-styler') ?></h4>
                            <p style="margin-bottom: 0;">
                                <?php _e('Start with creating your <a href="admin.php?page=wpcf7-new">first Contact Form 7</a>', 'cf7-styler') ?>
                            </p>
                            <?php
                        }
                        ?>
                    </div>
                </div>
                <!-- Select Form - End -->
            </div>

            <div id="cf7cstmzr-preview-container-body">
                <div id="form-preview-container" style="width:100%;height:100%;margin: auto;">
                    <div
                            id="form-preview-container_inner"
                            style="width:100%;height:100%;margin: auto;"
                    >
                        <?php
                        if (!empty($cf7_forms)) {
                            $cf7_form_id = $cf7_forms[0]->ID;
                            ?>
                            <iframe id="formPreviewFrame"
                                    title="Inline Frame Example"
                                    class="previous-iframe"
                                    style="width:100%;height:100%;"
                                    src="<?php echo get_site_url(); ?>/cf7cstmzr-form-customizer/<?php echo $cf7_form_id ?>?style_scheme=<?php echo $style_scheme_slug ?>">
                            </iframe>
                            <?php
                        } else {
                            ?>
                            <div style="padding: 35px 25px;">
                                <p style="text-align:center;">
                                    <?php _e('No Contact Form 7 items for preview', 'cf7-styler') ?>
                                </p>

                                <p style="text-align:center;">
                                    <?php _e('Start with creating your <a href="admin.php?page=wpcf7-new">first Contact Form 7</a>', 'cf7-styler') ?>
                                </p>
                            </div>
                            <?php
                        }
                        ?>
                    </div>
                </div>

                <div id="form-preview-container-temp" style="display: block;"></div>
            </div>
        </div>
    </div>
</div>

